/*
  The contents of this file are subject to the Initial Developer's Public
  License Version 1.0 (the "License"); you may not use this file except in
  compliance with the License. You may obtain a copy of the License here:
  http://www.flamerobin.org/license.html.

  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
  License for the specific language governing rights and limitations under
  the License.

  The Original Code is FlameRobin (TM).

  The Initial Developer of the Original Code is Gregory Sapunkov.

  Portions created by the original developer
  are Copyright (C) 2004 Gregory Sapunkov.

  All Rights Reserved.

  $Id: Subject.h,v 1.1 2005/08/29 20:32:36 mghie Exp $

  Contributor(s): Milan Babuskov.
*/

#ifndef FR_SUBJECT_H
#define FR_SUBJECT_H
//-----------------------------------------------------------------------------
#include <list>
#include <string>
#include <vector>

class Observer;
//-----------------------------------------------------------------------------
class Subject
{
protected:
    std::list<Observer*> observersM;
    int locksCountM;
    bool needsNotifyObjectsM;

public:
    Subject();
    virtual ~Subject();

    void attachObserver(Observer* observer);
    void detachObserver(Observer* observer);
    void detachAllObservers();
    void notifyObservers();
    void lockSubject();
    // TODO: remove parameters
    void unlockSubject(bool wantFullUnlock = false, bool doNotify = true);
};
//-----------------------------------------------------------------------------
#endif
